## mingw-w64-mlir-19.1.7-1.src.tar.zst

=== unittests/Support/CMakeLists.txt ===
add_mlir_unittest(MLIRSupportTests
  CyclicReplacerCacheTest.cpp
  IndentedOstreamTest.cpp
  StorageUniquerTest.cpp
)

target_link_libraries(MLIRSupportTests
  PRIVATE MLIRSupport)
